.586
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include proc_lister.inc

.code

start:
invoke GetModuleHandle,NULL
mov	hInstance,eax
invoke InitCommonControls
invoke DialogBoxParam,hInstance,DLG_MAIN,NULL,addr DlgProc,NULL
invoke ExitProcess,0

DlgProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

 .if uMsg ==  WM_INITDIALOG
          invoke _Init,hWnd
  
    .elseif uMsg ==  WM_COMMAND

          .if  wParam ==  1003
                     invoke SendMessage,hList1,LVM_DELETEALLITEMS,0,0
                     invoke  _FindProcess,hList1
          .endif
          
    .elseif uMsg ==  WM_NOTIFY
                push edi
                mov edi,lParam
                assume  edi:ptr NMHDR
                mov eax,[edi].hwndFrom
                
           .if eax ==  hList1
                 .if [edi].code ==  NM_CLICK
                          invoke SendMessage,hList2,LVM_DELETEALLITEMS,0,0   
                          invoke   _FindThread
                 .endif 
           .endif 
           
    .elseif uMsg ==  WM_CLOSE
                invoke EndDialog,hWnd,0
 .else
  mov eax,FALSE
  ret
 .endif
 mov eax,TRUE
 ret
DlgProc endp

_InsertColumn  proc hList,_lpHead1,_lpHead2,_lpHead3,_lpHead4,_lpHead5
local   @lvc:LV_COLUMN
                pushad
                mov     @lvc.imask,LVCF_TEXT+LVCF_WIDTH
                push    _lpHead1
                pop @lvc.pszText
                mov @lvc.lx,120
                invoke  SendMessage,hList,LVM_INSERTCOLUMN,0,addr @lvc
                or      @lvc.imask,LVCF_FMT
                mov     @lvc.fmt,LVCFMT_CENTER
                push    _lpHead2
                pop     @lvc.pszText
                mov     @lvc.lx,80
                invoke  SendMessage,hList,LVM_INSERTCOLUMN,1,addr @lvc
                push    _lpHead3
                pop     @lvc.pszText
                mov     @lvc.lx,80
                invoke  SendMessage,hList,LVM_INSERTCOLUMN,2,addr @lvc
                push    _lpHead4
                pop     @lvc.pszText
                mov     @lvc.lx,100
                invoke  SendMessage,hList,LVM_INSERTCOLUMN,3,addr @lvc 
                push    _lpHead5
                pop     @lvc.pszText
                mov     @lvc.lx,90
                invoke  SendMessage,hList,LVM_INSERTCOLUMN,4,addr @lvc
                popad
                ret
_InsertColumn endp
;**************************************************************************************************
_ShowProcess   proc    hList,row,lpFind
local   @stLvi:LV_ITEM
local   @szBuffer[20]:BYTE
                pushad
                mov edi,lpFind
                assume  edi :ptr PROCESSENTRY32
                mov     @stLvi.imask,LVIF_TEXT+LVIF_PARAM
                push    row
                pop     @stLvi.iItem
                mov     @stLvi.iSubItem,0
                lea     eax,[edi].szExeFile
                mov     @stLvi.pszText,eax
                push    row
                pop     @stLvi.lParam
                invoke  SendMessage,hList,LVM_INSERTITEM,0,addr @stLvi
                mov     @stLvi.imask,LVIF_TEXT
                inc     @stLvi.iSubItem
                invoke  wsprintf,addr @szBuffer,addr template,[edi].th32ParentProcessID
                lea     eax,@szBuffer
                mov     @stLvi.pszText,eax
                invoke  SendMessage,hList,LVM_SETITEM,0,addr @stLvi
                mov     @stLvi.imask,LVIF_TEXT
                inc     @stLvi.iSubItem
                invoke  wsprintf,addr @szBuffer,addr template,[edi].th32ProcessID
                lea     eax,@szBuffer
                mov     @stLvi.pszText,eax
                invoke  SendMessage,hList,LVM_SETITEM,0,addr @stLvi
                mov     @stLvi.imask,LVIF_TEXT
                inc     @stLvi.iSubItem
                invoke  wsprintf,addr @szBuffer,addr template,[edi].cntThreads
                lea     eax,@szBuffer
                mov     @stLvi.pszText,eax
                invoke  SendMessage,hList,LVM_SETITEM,0,addr @stLvi
                mov     @stLvi.imask,LVIF_TEXT
                inc     @stLvi.iSubItem
                invoke  wsprintf,addr @szBuffer,addr template,[edi].pcPriClassBase
                lea     eax,@szBuffer
                mov     @stLvi.pszText,eax
                invoke  SendMessage,hList,LVM_SETITEM,0,addr @stLvi
                assume  edi:nothing
                popad
                ret
_ShowProcess  endp
;**************************************************************************************************
_FindProcess  proc    _hList
local   @stProcess :PROCESSENTRY32
local   @hSnapShot
                invoke  RtlZeroMemory,addr @stProcess,sizeof @stProcess
                mov @stProcess.dwSize,sizeof @stProcess
                invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,0
                mov @hSnapShot,eax
                invoke  Process32First,@hSnapShot,addr @stProcess
                xor     edi,edi
                .while  eax
                            invoke  _ShowProcess,_hList,edi,addr @stProcess
                     invoke  Process32Next,@hSnapShot,addr @stProcess
                .endw
                invoke CloseHandle,@hSnapShot
                ret 
_FindProcess endp
;**************************************************************************************************
_Init proc uses ebx,hWnd
 
         invoke GetDlgItem,hWnd,IDC_LIST1
            mov hList1,eax
         invoke GetDlgItem,hWnd,IDC_LIST2
            mov hList2, eax
         invoke LoadIcon,hInstance,ICO_MAIN
         invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
            mov eax,LVS_EX_FULLROWSELECT or LVS_EX_HEADERDRAGDROP or\    
                                        LVS_EX_SUBITEMIMAGES or LVS_EX_GRIDLINES
            mov ebx,eax
         invoke SendMessage,hList1,LVM_SETEXTENDEDLISTVIEWSTYLE,0,eax   ;????
         invoke SendMessage,hList2,LVM_SETEXTENDEDLISTVIEWSTYLE,0,ebx   ;????
         invoke _InsertColumn,hList1,offset szProcess,offset szPaPid,offset szPid,\
                                                                     offset szTCount,offset szPri
         invoke _FindProcess,hList1
            RGB 0,0,255
         invoke SendMessage,hList1,LVM_SETTEXTCOLOR,0,eax          
         invoke _InsertColumn,hList2,offset szTid,offset szFid,\
                                            offset szUsage,offset szTpri,offset szSize
         ret
_Init endp
;**************************************************************************************************
_ShowThread  proc _hList,_dwRow,_lpFind
local   @stLvi:LV_ITEM
local   @szBuffer[20]:BYTE

     pushad
        mov edi,_lpFind
     assume edi :ptr THREADENTRY32
        mov @stLvi.imask,LVIF_TEXT+LVIF_PARAM
        RGB 255,0,255
     invoke SendMessage,hList2,LVM_SETTEXTCOLOR,0,eax
       push _dwRow
        pop @stLvi.iItem
        mov @stLvi.iSubItem,0
     invoke wsprintf,addr @szBuffer,addr template,[edi].th32ThreadID
        lea eax,@szBuffer
        mov @stLvi.pszText,eax
       push _dwRow
        pop @stLvi.lParam
     invoke SendMessage,hList2,LVM_INSERTITEM,0,addr @stLvi
        mov @stLvi.imask,LVIF_TEXT
        inc @stLvi.iSubItem
     invoke wsprintf,addr @szBuffer,addr template,[edi].th32OwnerProcessID
        lea eax,@szBuffer
        mov @stLvi.pszText,eax
     invoke SendMessage,_hList,LVM_SETITEM,0,addr @stLvi
        mov @stLvi.imask,LVIF_TEXT
        inc @stLvi.iSubItem
     invoke wsprintf,addr @szBuffer,addr template,[edi].cntUsage
        lea eax,@szBuffer
        mov @stLvi.pszText,eax
     invoke SendMessage,_hList,LVM_SETITEM,0,addr @stLvi
        mov @stLvi.imask,LVIF_TEXT
        inc @stLvi.iSubItem
     invoke wsprintf,addr @szBuffer,addr template,[edi].tpBasePri
        lea eax,@szBuffer
        mov @stLvi.pszText,eax
     invoke SendMessage,_hList,LVM_SETITEM,0,addr @stLvi
        mov @stLvi.imask,LVIF_TEXT
        inc @stLvi.iSubItem
     invoke wsprintf,addr @szBuffer,addr template,[edi].dwSize
        lea eax,@szBuffer
        mov @stLvi.pszText,eax
               
       invoke SendMessage,_hList,LVM_SETITEM,0,addr @stLvi
       assume edi:nothing
        popad
         ret
_ShowThread endp
;**************************************************************************************************
_FindThread proc
local  @stLvi:LV_ITEM
local  @szBuffer[256]:BYTE
local  @szBuffera[256]:BYTE
local  @stThread :THREADENTRY32
local  @hSnapShot

     pushad
     invoke SendMessage,hList1,LVM_GETNEXTITEM,-1,LVNI_FOCUSED
        mov @stLvi.iItem,eax
        mov @stLvi.iSubItem,2
        mov @stLvi.imask,LVIF_TEXT
        lea eax,@szBuffer
        mov @stLvi.pszText,eax
        mov @stLvi.cchTextMax,256
     invoke SendMessage,hList1,LVM_GETITEM,0,addr @stLvi
     invoke RtlZeroMemory,addr @stThread,sizeof @stThread
        mov @stThread.dwSize,sizeof @stThread
      invoke CreateToolhelp32Snapshot,TH32CS_SNAPTHREAD,0
        mov @hSnapShot,eax
     invoke Thread32First,@hSnapShot,addr @stThread
        xor edi,edi
        
    .while eax
           invoke wsprintf,addr @szBuffera,addr template,@stThread.th32OwnerProcessID
           invoke lstrcmpi,addr @szBuffer,addr @szBuffera 
            
       .if eax == 0
               invoke _ShowThread,hList2,edi,addr @stThread
                  inc edi
      .endif    
               invoke  Thread32Next,@hSnapShot,addr @stThread
    .endw
    
   invoke CloseHandle,@hSnapShot
    popad   
       ret
_FindThread endp

end start
